Zoj2421 广搜

<span style="color:#330099;">/*
M - 广搜 加强
Time Limit:2000MS     Memory Limit:65536KB     64bit IO Format:%lld & %llu
Submit

Status

Practice

ZOJ 2412
Description
Benny has a spacious farm land to irrigate. The farm land is a rectangle, and is divided into a lot of samll squares. Water pipes are placed in these squares. Different square has a different type of pipe. There are 11 types of pipes, which is marked from A to K, as Figure 1 shows.

Figure 1
Benny has a map of his farm, which is an array of marks denoting the distribution of water pipes over the whole farm. For example, if he has a map

ADC
FJK
IHE
then the water pipes are distributed like

Figure 2
Several wellsprings are found in the center of some squares, so water can flow along the pipes from one square to another. If water flow crosses one square, the whole farm land in this square is irrigated and will have a good harvest in autumn.

Now Benny wants to know at least how many wellsprings should be found to have the whole farm land irrigated. Can you help him?

Note: In the above example, at least 3 wellsprings are needed, as those red points in Figure 2 show.

Input
There are several test cases! In each test case, the first line contains 2 integers M and N, then M lines follow. In each of these lines, there are N characters, in the range of 'A' to 'K', denoting the type of water pipe over the corresponding square. A negative M or N denotes the end of input, else you can assume 1 <= M, N <= 50.

Output
For each test case, output in one line the least number of wellsprings needed.

Sample Input
2 2
DK
HF

3 3
ADC
FJK
IHE

-1 -1

Sample Output
2
3

By Grant Yuan
2014.7.14
Zoj 2421
*/
#include<iostream>
#include<cstdio>
#include<cstring>
#include<cstdlib>
using namespace std;

int aa[11][4]={{1,0,0,1},{1,1,0,0}, {0,0,1,1},{0,1,1,0},{1,0,1,0},
            {0,1,0,1},{1,1,0,1},{1,0,1,1},{0,1,1,1},{1,1,1,0},{1,1,1,1}};
int m,n;
char input[51][51];
bool mark[51][51];
int top,base;
int sum;
typedef struct{
 int x;
 int y;
}node;
node q[10000];
int next[4][2]={-1,0,0,1,1,0,0,-1};

bool can(int x1,int y1,int x2,int y2,int k)
{
    if(x1>=0&&x1<m&&y1>=0&&y1<n&&mark[x1][y1]==0)
     {

         if(aa[input[x2][y2]-65][k]==1)
           {
               if(k==0){
                if(aa[input[x1][y1]-65][2]==1)
                  return 1;}
              else if(k==1){
                 if(aa[input[x1][y1]-65][3]==1)
                  return 1;}
             else   if(k==2){
                 if(aa[input[x1][y1]-65][0]==1)
                  return 1;}
             else   if(k==3){
                 if(aa[input[x1][y1]-65][1]==1)
                  return 1;}
           }
     }
     return 0;
}

void slove()
{
    int a1,b1;
    int x1,y1;
    while(top>=base){
         a1=q[base].x;
         b1=q[base].y;
        for(int i=0;i<4;i++)
          {
              x1=a1+next[i][0];
              y1=b1+next[i][1];
              if(can(x1,y1,a1,b1,i)){
                mark[x1][y1]=1;
                q[++top].x=x1;
                q[top].y=y1;
                  }}
            base++;

      }
}

int main(){

  while(1){
    cin>>m>>n;
    if(m==-1&&n==-1)
      break;
    sum=0;
    memset(mark,0,sizeof(mark));
    for(int i=0;i<m;i++)
      scanf("%s",&input[i]);

    for(int i=0;i<m;i++)
       for(int j=0;j<n;j++)
        {
            if(mark[i][j]==0){
                sum++;
              top=-1;
              base=0;
              q[++top].x=i;
              q[top].y=j;
              mark[i][j]=1;
              slove();}
        }
        cout<<sum<<endl;

    }
    return 0;
  }
</span>

Zoj2421 广搜

时间: 2024-08-03 20:23:54

Zoj2421 广搜的相关文章

NYOJ 284 坦克大战 &amp;&amp; POJ 2312 Battle City (广搜+优先队列)

链接:click here~~ 题意: 描述 Many of us had played the game "Battle city" in our childhood, and some people (like me) even often play it on computer now. What we are discussing is a simple edition of this game. Given a map that consists of empty space

Catch That Cow(广搜)

个人心得:其实有关搜素或者地图啥的都可以用广搜,但要注意标志物不然会变得很复杂,想这题,忘记了标志,结果内存超时: 将每个动作扔入队列,但要注意如何更简便,更节省时间,空间 Farmer John has been informed of the location of a fugitive cow and wants to catch her immediately. He starts at a point N (0 ≤ N ≤ 100,000) on a number line and t

codevs 1225:八数码难题【双向广搜】

这里是传送门 这道题用普通BFS是可以做的,但是很明显没得过,效率太低了.效率更高的算法A*和双向广搜都可取,这写一下双向广搜的. 注意题目中的判重很重要,可以转化成九位数用hash来解决这个问题. #include <set> #include <string> #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> #define

迷宫广搜

上学期学了C,这学期学C++.感觉最难的还是算法,上周作业的一道广搜题是我第一次接触广搜,由于第一学期刚学编程就接触的太多的算法难题,不禁对代码产生畏惧,不过还好没有放弃,虽然算法很难,但我慢慢找到了一点学数学时的乐趣.先介绍一下这道未来的我看过来会觉得很简单一道题吧 You are provided a maze(迷宫), and you need to program to find the least steps to walk from the start to the end.And

宽搜和广搜、

广搜与深搜的小区别 一般来说,广搜常用于找单一的最短路线,或者是规模小的路径搜索,它的特点是"搜到就是最优解", 而深搜用于找多个解或者是"步数已知(好比3步就必需达到前提)"的标题,它的空间效率高,然则找到的不必定是最优解,必需记实并完成全数搜索,故一般情况下,深搜需要很是高效的剪枝(优化). 像搜索最短路径这些的很显著若是用广搜,因为广搜的特征就是一层一层往下搜的,保证当前搜到的都是最优解,当然,最短路径只是一方面的操作,像什么起码状态转换也是可以操作的.深搜就

hdu1241详解 Java广搜搞定

import java.util.Scanner; public class Main{ public static void main(String[] args) { Scanner sc = new Scanner(System.in); while (sc.hasNext()) { int m = sc.nextInt();//输入地图的行数 int n = sc.nextInt();//输入地图的列数 if (m == 0) {//若m=0则退出程序 break; } // 初始化图

poj 1166 The Clocks 记录路径的广搜

题意: 给9个时钟的初始状态,和一些对某几个钟的操作,求最少经过几步能到目标状态(全指向12点). 分析: 明显的广搜,但实现起来的细节要注意:1.因为要记录路径,所以要在整个程序执行过程中扩展出的节点在输出路径前不能销毁, 故采用静态内存分配的方法(开node[600000],用get_node()创建节点.2.queue<node>比queue<int>要多花1别的时间. //poj 1166 //sep9 #include <iostream> #include

nyoj 523 双向广搜

题目链接: http://acm.nyist.net/JudgeOnline/problem.php?pid=523 #include<iostream> #include<cstdio> #include<queue> using namespace std; /* 用普通搜索TLE,已知起点和终点,可以考虑双向广搜或A*算法加速搜索 双向广搜,一个方向从出发点向终点搜索,一个方向从终点向出发点搜索,搜索到相同的结点时,即找到最短路径. */ const int N

hdu 2717 Catch That Cow(广搜bfs)

题目链接:http://i.cnblogs.com/EditPosts.aspx?opt=1 Catch That Cow Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 7909    Accepted Submission(s): 2498 Problem Description Farmer John has been inform